"use strict";
/* eslint-disable unicorn/no-array-for-each, no-param-reassign */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const eslint_util_get_package_1 = __importDefault(require("@clark/eslint-util-get-package"));
const eslint_plugin_import_helpers_1 = require("eslint-plugin-import-helpers");
const PACKAGE = 'package';
const MATCH_NONE = '/foo/';
const ruleModule = Object.assign(Object.assign({}, eslint_plugin_import_helpers_1.rules['order-imports']), { create(context) {
        const options = context.options[0] || {};
        const groups = options.groups || [];
        let packageName;
        function getPackageName() {
            if (packageName)
                return packageName;
            const fileName = context.getFilename();
            const packageJSON = eslint_util_get_package_1.default(fileName);
            if (!packageJSON) {
                context.report({
                    message: `Could not find a valid 'package.json' for this file.`,
                    node: context.getScope().block
                });
                return MATCH_NONE;
            }
            if (!packageJSON.name) {
                context.report({
                    message: `Associated 'package.json' is missing a 'name' field.`,
                    node: context.getScope().block
                });
                return MATCH_NONE;
            }
            packageName = `/^${packageJSON.name.replace('/', '\\/')}/?/`;
            return packageName;
        }
        groups.forEach((block, i) => {
            if (block === PACKAGE) {
                groups[i] = getPackageName();
            }
            else if (Array.isArray(block)) {
                block.forEach((group, j) => {
                    if (group === PACKAGE) {
                        block[j] = getPackageName();
                    }
                });
            }
            else {
                context.report({
                    message: `Invalid 'groups' config: ${block}`,
                    node: context.getScope().block
                });
            }
        });
        context.options[0] = options;
        options.groups = groups;
        return eslint_plugin_import_helpers_1.rules['order-imports'].create(context);
    } });
exports.default = ruleModule;
